function b = FindNeighbors(bc,f,up,tol,maxit,X,y)
if nargin < 3
    error(' gradproj requires upper bound ');
end
%
% put initial iterate in feasible set
%
m=length(bc);
if norm(bc(1:m-1) - L1_projection(bc(1:m-1),up)) > 0
      disp(' initial iterate not feasibile ');
      bc(1:m-1)=L1_projection(bc(1:m-1),up);
end
alp=0.0001;
           if nargin < 5
              maxit=1000; 
           end
           if nargin < 4
              tol=0.000001;
           end
           
itc=1; 
[fc,gc]=feval(f,bc,X,y);
bt=L1_projection(bc - gc,up);        % projection of initial point
pgc=bc - L1_projection(bc - gc,up);
while(norm(pgc) > tol) && (itc <= maxit)
        lambda=5;
        bt=L1_projection(bc-lambda*gc,up); ft=feval(f,bt,X,y);
        iarm=0; 
        itc=itc+1;
        pl=bc - bt; 
        
        fgoal=fc-(pl'*pl)*(alp/lambda);
%
%       simple line search
%
        q0=fc; qp0=-gc'*gc; qc=ft;
	while(ft > fgoal)
                lambda=lambda*.1;
		iarm=iarm+1;
		bt=L1_projection(bc-lambda*gc,up);
        pl=bc-bt;
		ft=feval(f,bt,X,y); 
    	if(iarm > 10) 
		    disp(' Armijo error in gradient projection')
		    return; 
        end
                fgoal=fc-(pl'*pl)*(alp/lambda);
    end
    bc=bt; [fc,gc]=feval(f,bc,X,y); 
            pgc=bc-L1_projection(bc-gc,up);             
end
disp(['  iteration=' num2str(itc) '   Epslon=' num2str(norm(pgc)) '  norm(gradient)= ' num2str(norm(gc))]);
b=bc;

