clear;
day=clock;
disp(datestr(datenum(day(1),day(2),day(3),day(4),day(5),day(6)),0))
f='f';               % objective function
%_____________________________________________________
%
[CanEXP,GeneSymbols]=xlsread('DataCancerEXP.xlsx'); 
[NorEXP,~]=xlsread('DataNormalEXP.xlsx');
[CanCNV,~]=xlsread('DataCancerCN.xlsx');
[NorCNV,~]=xlsread('DataNormalCN.xlsx');
[~,PPI]=xlsread('PPI.xlsx');
[m,n]=size(CanEXP);
a=zeros(n);
%Compute the expected degree of each gene on PPI network
%_____________________________________________________
%
Adj=Adjacency(PPI,GeneSymbols);
maxNeighbor=max(sum(Adj));
up=1+sum(Adj)/maxNeighbor;
%_______________________________  
% Obtaining the sparse covariance matrix
b0=ones(n,1); %Starting point for a gradientian projection method
for k=1:n
    disp(['Incoming edges of Gene k= ' num2str(k) ' Expected degree of weight = ' num2str(up(k))]);
    y=CanEXP(:,k);                                 %Choose response data
    X=CanCNV;                                      %Choose explanatory data
    %X(:,k)=0;  % In case both response data and explanatory data are
    %selected from same data, we use X(:,k)=0 to remove the response vector
    %from the explanatory data matrix
    tol=0.000001; % Tolerance value for accuracy
    maxit=30;
    a(:,k)= FindNeighbors(b0,f,up(k),tol,maxit,X,y); % For k-th gene, compute the incoming effects
end
dlmwrite('PartialCorrMatrix.txt',abs(coVar));
%Center the normal and cancer samples respectively and compute the standard
%deviations over all cancer and normal samples to measure changes of each
%gene between normal and cancer conditions
%_____________________________________________________
%
EXP=[CenterD(CanEXP);CenterD(NorEXP)];    
CNV=[CenterD(CanCNV);CenterD(NorCNV)];
sigmaEXP=std(EXP);
sigmaCNV=std(CNV);
%copmute the partial covariance using the standard deviations and partial
%correlation matrix
%_____________________________________________________
%
coVar=zeros(n,n);
for i=1:n
   for j=1:n
        coVar(i,j)=a(i,j)*sigmaCNV(i)*sigmaEXP(j);
   end
end
dlmwrite('PartialCovMatrix.txt',abs(coVar)); %Output the partial covariance matrix
day=clock;
disp(datestr(datenum(day(1),day(2),day(3),day(4),day(5),day(6)),0))
